<?php

namespace Drupal\embed_link\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;
use \Drupal\views\Views;

/**
 * EmbedLinkController class.
 */
class EmbedLinkController extends ControllerBase {

  // cssの指定
  const CSS_LINK = '<link rel="stylesheet" media="all" href="/themes/drupal_study/css/embed.css"/>';
  // リンク先をiframe内ではなく、ウィンドウ全体に開く。
  const LINK_TARGET = '<base target="_top">';
  // 検索エンジンに、このページはインデックス化して欲しくないけど、リンクはたどって欲しい
  const ROBOT_NO_INDEX = '<meta name="robots" content="noindex, follow" />';

  /**
   * iframe用のHTMLを取得する
   *
   * @param  $node_id
   *   Node ID  
   * @return $response
   *   HTMLの文字列を返す
   */
  public function content($node_id) {

    // blog_summaryビューを取得  display_id:block_1  引数:$node_id
    $content =  views_embed_view('blog_summary','block_1',$node_id);

    // HTMLに変換
    $renderer = \Drupal::service('renderer');
    $body = $renderer->render($content);

    // head 
    $head = self::CSS_LINK . self::LINK_TARGET . self::ROBOT_NO_INDEX;
    // html全体
    $html = "<head>$head</head><body>$body</body>";

    // symfonyのResponse
    $response = new Response();
    $response->setContent($html);

    return $response;

  }

}

